/*
	editstations.h

	Copyright (c) 2009 by Lms <lms.cze7@gmail.com>

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
*/

#ifndef EDITSTATIONS_H
#define EDITSTATIONS_H

#include <QtGui/QDialog>
#include <QtSql>
#include <QMessageBox>
#include <QTreeWidget>
#include <QFileDialog>
#include <QXmlStreamWriter>
#include <QXmlStreamReader>
#include "sqliteengine.h"

namespace Ui {
    class EditStations;
}

class EditStations : public QDialog {
    Q_OBJECT
public:
    EditStations(QWidget *parent = 0);
    ~EditStations();

	SQLiteEngine sqldb;

	void showEvent();
	void showStations();
	void showStreams();

private slots:
	void stationsChanged(QTreeWidgetItem *current,QTreeWidgetItem *before);
	void streamsChanged(QTreeWidgetItem *current,QTreeWidgetItem *before);
	void clickSave();

	void clickStationsAdd();
	void clickStationsDelete();
	void clickStreamsAdd();
	void clickStreamsDelete();

	void clickStationsUp();
	void clickStationsDown();
	void clickStreamsUp();
	void clickStreamsDown();

	void clickImport();
	void clickExport();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::EditStations *m_ui;
};

#endif // EDITSTATIONS_H
